/* Program salje ulazni podatak na paralelni port
lptout adresa_porta podatak_koji_se_salje

*/


#include <stdio.h>
#include <conio.h>
#include <windows.h>


/* Funkcije ugraene u inpout32.dll :            */
/*   short _stdcall Inp32(short PortAddress);               */
/*   void _stdcall Out32(short PortAddress, short data);    */


/* prototype (function typedef) for DLL function Inp32: */

     typedef short _stdcall (*inpfuncPtr)(short portaddr);
     typedef void _stdcall (*oupfuncPtr)(short portaddr, short datum);

int main(int argc, char **argv)
{
     HINSTANCE hLib;
     inpfuncPtr inp32;
     oupfuncPtr oup32;

    short x;
    short value;
    short lpt_adr;

     /* ucitavanje inpout32.dll */
     hLib = LoadLibrary("inpout32.dll");
     if (hLib == NULL) {
          printf("inpout32.dll kopirati u system32 direktorij.\n");
          return -1;
     }

     /* get the address of the function */
   
     oup32 = (oupfuncPtr) GetProcAddress(hLib, "Out32");

     if (oup32 == NULL) {
          printf("GetProcAddress for Oup32 Failed.\n");
          return -1;
     }
if (argc!=3)
    fprintf(stderr, "potrebno je upisati ulazne parametre,\n adresa porta i podatak koji se salje\n lptout lpt_adr podatak"), exit(1);
    
// ucitava adresu lpt porta
if (sscanf(argv[1],"%i",&lpt_adr)!=1)
    fprintf(stderr, "nije dobra adresa lpt porta\n"), exit(1);
    
//ucitava podatak koji se salje na lpt port
if (sscanf(argv[2],"%i",&value)!=1)
    fprintf(stderr, "drugi parametar je dec ili hex broj\n"), exit(1);

     /*Dio koda koji upisuje podatak u LPT registar*/

    (oup32)(lpt_adr,value);

    

//oslobadja inpout32.dll
     FreeLibrary(hLib);
     return 0;
}
